#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use HTML::Template;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::ServerGroups;
use PureMessage::Manager::Widget;
use PureMessage::Manager::Lang;
use PureMessage::ServerGroup qw (:all);
use PureMessage::RPC::Client; # client lib

my %vars;
our %text;

my $WIDGET = new PureMessage::Manager::Widget;


my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::ServerGroups',
                                'stderr_to_stdout' =>1
                              );

$r->add_help(text => "Help", tab => "servgrp", page => "mgr_servgrp_addgrp" );

my $group_name = $in{name};
my $load_data = $in{load} ? 1 : 0; # won't be defined if this is the first page view
my $group = get_group($group_name) if $load_data;
my $mode = ($in{load} || $in{update}) ? 'Edit' : 'Create';

$r->title(&text('edit_group_title',$mode));

my $w_event = $WIDGET->read_input($REQUEST);


if ($in{save}) {
        if(validData(\%in)) {
                my $save_error;
           
                eval {
                        my %data = ( description => $in{description},
                                   );
                        if($in{real_group} ne $group_name) {
                                rename_group($in{real_group},$group_name);
                        }
                        $save_error = ! save_group($group_name,\%data);
                     };
                     if ($@ or $save_error ) {
                        my $error = $@;
                        $error = &text('unable_to_save_group',$group_name) if $save_error;
                        $r->raise_error('error_edit_group',$group_name,$error);
                        putPage();
                     } else {
                     
                        $r->dialog( style => 'dlg_info',
                                    msg => &text("group_edited",$group_name,$mode),
                                    title=>text('group_updated_title'),
                                    buttons => [[ { type=>'image', icon=>'continue',text=>'Continue',href=>'index.cgi'} ]],
                                  );
                     }
                
        } else {
                putPage();
        }
        
} elsif ($in{'delete'}) {
        # then ask if they want to delete...
        $r->dialog( style=>'dlg_query',
                    msg=>&text('group_delete_query',$group_name),
                    title=>text('group_delete_query_title'),
                    state => { name => $group_name, load => 1},
                    buttons => [[ {type=>'image', icon=>'delete', name=>'confirm_delete', text => 'Yes Delete'},
                                  {type=>'image', icon=>'cancel',name=>'no',text=>'No Cancel'}
                               ]],
                  );

} elsif($WIDGET->query('confirm_delete')) {
        eval {
                del_group($group_name);
        }; 
        if ($@) {
          $r->raise_error('error_deleting_group',$group_name,$@);
          $r->error_dlg();
        } else {

                $r->dialog( style => 'dlg_info',
                            msg => &text("group_deleted",$group_name),
                            title=>text('group_deleted_title'),
                            buttons => [[ { type=>'image', icon=>'continue',text=>'Continue',href=>'index.cgi'} ]],
                  );
        }
        
}else {
        putPage($load_data);
}


$r->send();

# functions

sub validData {
     $REQUEST->typedecl("name", "#hb_as_option #value", "Group");
     $REQUEST->typedecl("description", "#nomarkup #value", "Description");
     my @v_errors = $REQUEST->validate();
     if (@v_errors) {
         $r->raise_error(join("<br>", @v_errors));
         return;
     } else {
         return 1;
     }
}

sub loadData {
 
        $vars{description} = $group->{description};
        $vars{name} = $group_name;
       
}

sub readInput {

        foreach my $input ( qw (name description)) {
                $vars{$input} = $in{$input};
        }

}

sub putPage {
        my $load = shift;
        my %state;

        if ($load) {
                $state{real_group} = $group_name;
                $state{update} =1;
                loadData();
        } else {
                readInput();
                $state{update} = $in{update};
                $state{real_group} = $in{real_group};
        }

        my @buttons = ({ type=>'icon',icon=>'save',text=>'Save', name=>'save'});
        push(@buttons,{ type=>'icon',icon=>'delete',text=>'Delete',name=>'delete'}) if $state{update};
        push(@buttons,{ type=>'icon',icon=>'cancel',text=>'Cancel', href=>'index.cgi'});

        my $tb = $WIDGET->widget(CLASS =>'PureMessage::Manager::Widget::ToolBar',
                                 name => 'tb',
                                 buttons => [\@buttons ],
                                 width=>600,
                                 state => \%state,
                                );
        
        $vars{HEADER} = $r->ThemeSectionHeader( title=> &text('edit_group_dialog_title',$mode))->output;
        $vars{FOOTER} = $r->ThemeSectionFooter( toolbar => $tb)->output;
 
        
        my $template = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::Template',
                                   data => \%vars,
                                   filename => 'group',
                                   width=>600,
                                   );


        $r->add_part($template,'body_form');

}

