#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::ServerGroups;
use PureMessage::Manager::Widget;
use PureMessage::Manager::Lang;
use PureMessage::ServerGroup qw (:all);
use PureMessage::RPC::Client; # client lib

my %vars;
our %text;

my $WIDGET = new PureMessage::Manager::Widget;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::ServerGroups',
                                'stderr_to_stdout' =>1
                              );

$r->add_help(text => "Help", tab => "servgrp", page => "mgr_servgrp_addhost" );

$r->title('server_addpage_title');
my $alias = $in{alias};

my $w_event = $WIDGET->read_input($REQUEST);

if ($in{save}) {
        if(validData(\%in)) {
                my $save_error;
                eval {
                        my %data = ( description => $in{description},
                                     host => $in{hostname},
                                     port => $in{port},
                                   );
                        $data{user} = $in{username};
                        $data{pass} = $in{password};

                        my @groups = map { $_ =~ s/^group_//; $_} grep { /^group_/ } keys %in;
                        $data{group} = \@groups;
                        
                        $save_error = ! save_host($alias,\%data);
                     };
                     if ($@ or $save_error) {
                        my $error = $@;
                        $error = &text('unable_to_save') if $save_error;
                        $r->raise_error('error_creating_host',$alias,$error);
                        putPage();
                     } else {
                     
                        $r->dialog( style => 'dlg_info',
                                    msg => &text("host_created",$alias),
                                    title=>text('host_created_title'),
                                    buttons => [[ { type=>'image', icon=>'continue', text=>'Continue',href=>'index.cgi'} ]],
                                  );
                     }
                
        } else {
                putPage();
        }
} elsif($in{test}) {
        $vars{test} = 1;
        $vars{valid_auth} = PureMessage::ServerGroup::get_auth_key({ host => $in{hostname}, port => $in{port},
                                           user=>$in{username}, pass=> $in{password}
                                        });
        putPage();
} else {
        putPage();
}


$r->send();

# functions

sub validData {
        my $in = shift;
        $REQUEST->typedecl("hostname", "#value", "Hostname");
        $REQUEST->typedecl("port", "#int #value", "Port");
        $REQUEST->typedecl("alias", "#value #hb_as_group_name", "Alias");
        $REQUEST->typedecl("username", "#word", "Username");
        $REQUEST->typedecl("description", "#nomarkup #value", "Description");
        my @v_errors = $REQUEST->validate();
        if (@v_errors) {
            $r->raise_error(join("<br>", @v_errors));
            return;
        } else {
            return 1;
        }
}


sub readInput {

        foreach my $input ( qw (description port hostname username password alias)) {
                $vars{$input} = $in{$input};
        }
        my %groups_in = map { $_ =~ s/^group_//; ($_ => 1) } grep { /^group_/ && $in{$_} =~ /checked|on/i } keys %in;
        my @groups_loop;
        my $groups = get_groups();
        foreach my $group (sort keys %$groups) {
                next if $group eq "\0";
                push(@groups_loop,{ name=>$group, checked=> $groups_in{$group} ? 1 : 0});
        }
        $vars{GROUPS}  = \@groups_loop;

}



sub putPage {
        readInput();
        my $tb = $WIDGET->widget(CLASS =>'PureMessage::Manager::Widget::ToolBar',
                                 name => 'tb',
                                 buttons => [[ 
                                               { type=>'icon',icon=>'save',text=>'Save', name=>'save'},
                                               { type=>'icon',icon=>'cancel',text=>'Cancel', href=>'index.cgi'},
                                             ], 
                                             ],
                                 width=>600,
                                );
        $vars{HEADER} = $r->ThemeSectionHeader( title=> &text('server_addpage_dialog_title',$in{hostname}))->output;
        $vars{FOOTER} = $r->ThemeSectionFooter( toolbar => $tb)->output;
        my $template = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::Template',
                                   data => \%vars,
                                   filename => 'host',
                                   );

        $r->add_part($template,'body_form');

}




