package PureMessage::ServerGroup::Utils;
use Carp;
use strict;
use base 'Exporter';
use vars qw(@EXPORT);
our @EXPORT = qw(to_ipaddress);

sub to_ipaddress
{
    if (&check_ipaddress($_[0])) {
        return $_[0];
    }
    else {
        my @ip;
        @ip = unpack("CCCC", gethostbyname($_[0]));
        if (@ip) { return join("." , @ip); }
        else { return undef; }
    }
}

# Check if some IP address is properly formatted
sub check_ipaddress
{
    return $_[0] =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/ &&
            $1 >= 0 && $1 <= 255 &&
            $2 >= 0 && $2 <= 255 &&
            $3 >= 0 && $3 <= 255 &&
            $4 >= 0 && $4 <= 255;
}

1;
